Attribute VB_Name = "Module1"
Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long

Global DefaultPlayer As String
Global TempPath As String

Type ID3Tag
    Name As String * 30
    Artist As String * 30
    Album As String * 30
    Date As String * 4
    Comments As String * 30
    Style As Byte
End Type

Sub GetTag(FileName As String, Information As ID3Tag)
Dim File As Integer
Dim TagPrint As String * 3
Information.Album = ""
Information.Artist = ""
Information.Comments = ""
Information.Date = ""
Information.Name = ""
Information.Style = 255
File = FreeFile
On Error Resume Next
Open FileName For Binary As File
    Get File, LOF(File) - Len(Information) - 2, TagPrint
    If TagPrint = "TAG" Then
        Get File, , Information
    End If
Close File
End Sub

Function Style(ID As Byte) As String
Select Case ID
    Case 0
        Style = "Blues"
    Case 1
        Style = "Classic Rock"
    Case 2
        Style = "Country"
    Case 3
        Style = "Dance"
    Case 4
        Style = "Disco"
    Case 5
        Style = "Funk"
    Case 6
        Style = "Grunge"
    Case 7
        Style = "Hip-Hop"
    Case 8
        Style = "Jazz"
    Case 9
        Style = "Metal"
    Case 10
        Style = "New Age"
    Case 11
        Style = "Oldies"
    Case 12
        Style = "Other"
    Case 13
        Style = "Pop"
    Case 14
        Style = "R&B"
    Case 15
        Style = "Rap"
    Case 16
        Style = "Reggae"
    Case 17
        Style = "Rock"
    Case 18
        Style = "Techno"
    Case 19
        Style = "Industrial"
    Case 20
        Style = "Alternative"
    Case 21
        Style = "Ska"
    Case 22
        Style = "Death Metal"
    Case 23
        Style = "Pranks"
    Case 24
        Style = "Soundtrack"
    Case 25
        Style = "Euro-Techno"
    Case 26
        Style = "Ambient"
    Case 27
        Style = "Trip-Hop"
    Case 28
        Style = "Vocal"
    Case 29
        Style = "Jazz+Funk"
    Case 30
        Style = "Fusion"
    Case 31
        Style = "Trance"
    Case 32
        Style = "Classical"
    Case 33
        Style = "Instrumental"
    Case 34
        Style = "Acid"
    Case 35
        Style = "House"
    Case 36
        Style = "Game"
    Case 37
        Style = "Sound Clip"
    Case 38
        Style = "Gospel"
    Case 39
        Style = "Noise"
    Case 40
        Style = "AlternRock"
    Case 41
        Style = "Bass"
    Case 42
        Style = "Soul"
    Case 43
        Style = "Punk"
    Case 44
        Style = "Space"
    Case 45
        Style = "Meditative"
    Case 46
        Style = "Instrumental Pop"
    Case 47
        Style = "Instrumental Rock"
    Case 48
        Style = "Ethnic"
    Case 49
        Style = "Gothic"
    Case 50
        Style = "Darkwave"
    Case 51
        Style = "Techno-Industrial"
    Case 52
        Style = "Electronic"
    Case 53
        Style = "Pop-Folk"
    Case 54
        Style = "Eurodance"
    Case 55
        Style = "Dream"
    Case 56
        Style = "Southern Rock"
    Case 57
        Style = "Comedy"
    Case 58
        Style = "Cult"
    Case 59
        Style = "Gangsta"
    Case 60
        Style = "Top 40"
    Case 61
        Style = "Christian Rap"
    Case 62
        Style = "Pop/Funk"
    Case 63
        Style = "Jungle"
    Case 64
        Style = "Native American"
    Case 65
        Style = "Cabaret"
    Case 66
        Style = "New Wave"
    Case 67
        Style = "Psychadelic"
    Case 68
        Style = "Rave"
    Case 69
        Style = "Showtunes"
    Case 70
        Style = "Trailer"
    Case 71
        Style = "Lo-Fi"
    Case 72
        Style = "Tribal"
    Case 73
        Style = "Acid Punk"
    Case 74
        Style = "Acid Jazz"
    Case 75
        Style = "Polka"
    Case 76
        Style = "Retro"
    Case 77
        Style = "Musical"
    Case 78
        Style = "Rock & Roll"
    Case 79
        Style = "Hard Rock"
    Case 80
        Style = "Folk"
    Case 81
        Style = "Folk-Rock"
    Case 82
        Style = "National Folk"
    Case 83
        Style = "Swing"
    Case 84
        Style = "Fast Fusion"
    Case 85
        Style = "Bebob"
    Case 86
        Style = "Latin"
    Case 87
        Style = "Revival"
    Case 88
        Style = "Celtic"
    Case 89
        Style = "Bluegrass"
    Case 90
        Style = "Avantgarde"
    Case 91
        Style = "Gothic Rock"
    Case 92
        Style = "Progressive Rock"
    Case 93
        Style = "Psychedelic Rock"
    Case 94
        Style = "Symphonic Rock"
    Case 95
        Style = "Slow Rock"
    Case 96
        Style = "Big Band"
    Case 97
        Style = "Chorus"
    Case 98
        Style = "Easy Listening"
    Case 99
        Style = "Acoustic"
    Case 100
        Style = "Humour"
    Case 101
        Style = "Speech"
    Case 102
        Style = "Chanson"
    Case 103
        Style = "Opera"
    Case 104
        Style = "Chamber Music"
    Case 105
        Style = "Sonata"
    Case 106
        Style = "Symphony"
    Case 107
        Style = "Booty Bass"
    Case 108
        Style = "Primus"
    Case 109
        Style = "Porn Groove"
    Case 110
        Style = "Satire"
    Case 111
        Style = "Slow Jam"
    Case 112
        Style = "Club"
    Case 113
        Style = "Tango"
    Case 114
        Style = "Samba"
    Case 115
        Style = "Folklore"
    Case 116
        Style = "Ballad"
    Case 117
        Style = "Power Ballad"
    Case 118
        Style = "Rhythmic Soul"
    Case 119
        Style = "Freestyle"
    Case 120
        Style = "Duet"
    Case 121
        Style = "Punk Rock"
    Case 122
        Style = "Drum Solo"
    Case 123
        Style = "Acapella"
    Case 124
        Style = "Euro-House"
    Case 125
        Style = "Dance Hall"
    Case 255
        Style = "Unknown"
End Select
End Function

Sub SaveTag(FileName As String, Information As ID3Tag)
Dim File As Integer
Dim TagPrint As String * 3
On Error Resume Next
File = FreeFile
Open FileName For Binary As File
    Get File, LOF(File) - Len(Information) - 2, TagPrint
    If TagPrint = "TAG" Then
        Put File, , Information
    Else
        If LOF(File) = 0 Then
            Put File, 1, "TAG"
            Put File, , Information
        Else
            Put File, LOF(File), "TAG"
            Put File, , Information
        End If
    End If
Close File
End Sub

Sub Main()
Dim filetype$
TempPath = String(255, " ")
GetTempPath Len(TempPath), TempPath
filetype$ = getstring(HKEY_CLASSES_ROOT, ".mp3", "")
If filetype$ = "" Then Exit Sub
Action$ = getstring(HKEY_CLASSES_ROOT, filetype$ & "\shell", "")
If Action$ = "" Then Exit Sub
DefaultPlayer = getstring(HKEY_CLASSES_ROOT, filetype$ & "\shell\" & Action$ & "\command", "")
End Sub

Sub Play(FileName As String)
If DefaultPlayer = "" Then
    MsgBox "You have no program associated with MP3 files"
    Exit Sub
End If
Dim InsertFile As Integer
InsertFile = InStr(1, DefaultPlayer, "%1")
If InsertFile = 0 Then
    Shell DefaultPlayer & " " & FileName
Else
    Shell Mid$(DefaultPlayer, 1, InsertFile - 1) & FileName & Mid$(DefaultPlayer, InsertFile + 2)
End If
End Sub

Function ReplaceInString(ByVal InputString As String, Replacments() As String) As String
Dim LastOccurence As Long
    For i = LBound(Replacments) To UBound(Replacments)
        LastOccurence = 1
        LastOccurence = InStr(LastOccurence, InputString, Replacments(i, 1))
        Do Until LastOccurence = 0
            InputString = Mid$(InputString, 1, LastOccurence - 1) & Replacments(i, 2) & Mid$(InputString, LastOccurence + 2)
            LastOccurence = InStr(LastOccurence, InputString, Replacments(i, 1))
        Loop
    Next
    ReplaceInString = InputString
End Function

Function GetPath(ByVal FileName As String) As String
Dim LastPosition As Long
Dim LastPosition1 As Long
LastPosition = 1
Do Until LastPosition = 0
    LastPosition1 = LastPosition
    LastPosition = InStr(LastPosition + 1, FileName, "\")
Loop
GetPath = Mid$(FileName, 1, LastPosition1)
End Function

Function GetFileName(ByVal FileName As String) As String
Dim LastPosition As Long
Dim LastPosition1 As Long
LastPosition = 1
Do Until LastPosition = 0
    LastPosition1 = LastPosition
    LastPosition = InStr(LastPosition + 1, FileName, "\")
Loop
GetFileName = Mid$(FileName, LastPosition1 + 1)
End Function

Function TrimNull(ByVal InputString As String) As String
Dim FirstNull As Integer
InputString = Trim(InputString)
FirstNull = InStr(1, InputString, Chr$(0))
If FirstNull = 0 Then
    TrimNull = InputString
Else
    TrimNull = Mid$(InputString, 1, FirstNull - 1)
End If
End Function
